﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace UltraCombo_ReadOnly
{
    public partial class Form1 : Form
    {
        private DataTable data = null;

        public Form1()
        {
            InitializeComponent();
            this.ultraCombo.ValueMember = "Value";
            this.ultraCombo.DisplayMember = "Display";
            this.ultraCombo.SetDataBinding( this.Data, null );
            this.ultraCombo.ReadOnly = true;
            EditorButton button = new EditorButton();
            this.ultraCombo.ButtonsLeft.Add(button);
            this.ultraCombo.EditorButtonClick += new EditorButtonEventHandler(ultraCombo_EditorButtonClick);
        }

        void ultraCombo_EditorButtonClick(object sender, EditorButtonEventArgs e)
        {
            UltraCombo combo = sender as UltraCombo;
            combo.ReadOnly = !combo.ReadOnly;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox control = sender as CheckBox;
            this.ultraCombo.DropDownStyle =
                control.Checked ?
                Infragistics.Win.UltraWinGrid.UltraComboStyle.DropDownList :
                Infragistics.Win.UltraWinGrid.UltraComboStyle.DropDown;
        }

        private DataTable Data
        {
            get
            {
                if ( this.data == null )
                {
                    this.data = new DataTable();
                    this.data.Columns.Add( "Value", typeof(int) );
                    this.data.Columns.Add( "Display", typeof(string) );

                    this.data.Rows.Add( new object[]{ 1, "1.1" } );
                    this.data.Rows.Add( new object[]{ 2, "1.2" } );
                    this.data.Rows.Add( new object[]{ 3, "1.3" } );

                    this.data.Rows.Add( new object[]{ 4, "2.1" } );
                    this.data.Rows.Add( new object[]{ 5, "2.2" } );
                    this.data.Rows.Add( new object[]{ 6, "2.3" } );

                    this.data.Rows.Add( new object[]{ 7, "3.1" } );
                    this.data.Rows.Add( new object[]{ 8, "3.2" } );
                    this.data.Rows.Add( new object[]{ 9, "3.3" } );
                }

                return this.data;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.ultraCombo.ReadOnly = !this.ultraCombo.ReadOnly;
        }
    }
}
